//Robot Roundup (Duo)
//Script by John Worden (MilkMaster72)
ClearGameEventCallbacks()
local pdLogic = Entities.FindByName(null, "logic_pd")
local timer = Entities.FindByName(null, "timer")
local gamerules = Entities.FindByName(null, "gamerules")
local roundOver = false
local overtime = false
local respawnWinner = Entities.FindByName(null, "respawn_winner_*").GetName().slice(15)
local respawnLoser = Entities.FindByName(null, "respawn_loser_*").GetName().slice(14)
local respawnNeutral = Entities.FindByName(null, "respawn_neutral_*").GetName().slice(16)
local respawnDifference = Entities.FindByName(null, "respawn_difference_*").GetName().slice(19).tointeger()
local respawnRobot = Entities.FindByName(null, "robot_respawn_*").GetName().slice(14).tointeger() 
function Tick()
{
    if (overtime == true)
        CompareScores()
}
function OnGameEvent_rd_robot_killed(params) //Robot destroyed
{
    if (roundOver == true)
        return

    local attacker = GetPlayerFromUserID(params.attacker)
    if (attacker.GetTeam() == 3) //BLU Attacker
        {EntFireByHandle(pdLogic, "scorebluepoints", null, 0, null, null)
        RobotRespawn(0)} //Respawn RED
    else if (attacker.GetTeam() == 2) //RED Attacker
        {EntFireByHandle(pdLogic, "scoreredpoints", null, 0, null, null)
        RobotRespawn(1)} //Respawn BLU

    PlayerRespawnTimes()
}
function CompareScores() //Round is over, compare scores
{
    local redScore = NetProps.GetPropInt(pdLogic, "m_nRedScore")
    local blueScore = NetProps.GetPropInt(pdLogic, "m_nBlueScore")
    if (redScore > blueScore) //RED wins
    {
        WinRed()
        roundOver = true
        overtime = false
        NetProps.SetPropInt(gamerules, "m_bInOvertime", 0)
    }
    else if (redScore < blueScore) //BLU wins
    {
        WinBlue()
        roundOver = true
        overtime = false
        NetProps.SetPropInt(gamerules, "m_bInOvertime", 0)
    }
    else if (redScore == blueScore) //Overtime
    {
        overtime = true
        NetProps.SetPropInt(gamerules, "m_bInOvertime", 1)
    }
}
function WinRed()
{
    EntFire("cp_1", "setowner", "2", 0, null)
    EntFire("cap_b_relay", "trigger", null, 0, null)
    DestroyLoserBots(0)
}
function WinBlue()
{
    EntFire("cp_2", "setowner", "3", 0, null)
    EntFire("cap_a_relay", "trigger", null, 0, null)
    DestroyLoserBots(1)
}
function PlayerRespawnTimes()
{
    local redScore = NetProps.GetPropInt(pdLogic, "m_nRedScore")
    local blueScore = NetProps.GetPropInt(pdLogic, "m_nBlueScore")

    if (redScore > blueScore + respawnDifference) //RED winning
    {
        EntFireByHandle(gamerules, "setredteamrespawnwavetime", respawnWinner, 0, null, null) //RED
        EntFireByHandle(gamerules, "setblueteamrespawnwavetime", respawnLoser, 0, null, null) //BLU
    }
    else if (blueScore > redScore + respawnDifference) //BLU winning
    {
        EntFireByHandle(gamerules, "setblueteamrespawnwavetime", respawnWinner, 0, null, null) //BLU
        EntFireByHandle(gamerules, "setredteamrespawnwavetime", respawnLoser, 0, null, null) //RED
    }
    else //Neutral enough
    {
        EntFireByHandle(gamerules, "setredteamrespawnwavetime", respawnNeutral, 0, null, null) //RED
        EntFireByHandle(gamerules, "setblueteamrespawnwavetime", respawnNeutral, 0, null, null) //BLU
    }
}
function RobotRespawn(teamValue)
{
    if (teamValue == 0) //RED bot
        EntFire("robot_spawn_a", "spawnrobot", null, respawnRobot, null)
    else if (teamValue == 1)
        EntFire("robot_spawn_b", "spawnrobot", null, respawnRobot, null)
}
function DestroyLoserBots(teamValue)
{
    EntFire("robot_spawn_a", "cancelpending", null, 0, null)
    EntFire("robot_spawn_b", "cancelpending", null, 0, null)
    for (local ent; ent = Entities.FindByClassname(ent, "tf_robot_destruction_robot"); )
    {
        if (teamValue == 0) //RED wins
            if (NetProps.GetPropInt(ent, "m_iTeamNum") == 3) //Bot is BLU
                NetProps.SetPropInt(ent, "m_iHealth", 0)
        else if (teamValue == 1) //BLU wins
            if (NetProps.GetPropInt(ent, "m_iTeamNum") == 2) //Bot is RED
                NetProps.SetPropInt(ent, "m_iHealth", 0)
    }
}
__CollectGameEventCallbacks(this)